using UnityEngine;
using System.Collections;

public class Camera_Motion : MonoBehaviour {

    public Vector2 MinPosition;
    public Vector2 MaxPosition;
    public float Velocity;
    public int MaxZoom;
    public float DeltaZoom;

    private int Zoom;
	
    void Start () {
        Zoom = 0;
	}
	
	void Update () {

        if ((Input.GetAxis("Mouse ScrollWheel") > 0) && (Zoom < MaxZoom) && (transform.position.y > DeltaZoom+30))
        {
            Zoom++;
            transform.Translate(Vector3.forward*DeltaZoom);
        }
        if ((Input.GetAxis("Mouse ScrollWheel") < 0) && ((-Zoom) < MaxZoom))
        {
            Zoom--;
            transform.Translate(Vector3.back * DeltaZoom);
        }
        float horizontal = Input.GetAxis("Horizontal")*Time.deltaTime;
        float vertical = Input.GetAxis("Vertical") * Time.deltaTime;
        Vector3 forward = (new Vector3(transform.up.x, 0, transform.up.z))*vertical;
        Vector3 right = (new Vector3(transform.right.x, 0, transform.right.z))*horizontal;

        float x = transform.position.x + ((forward+right).normalized).x*Velocity;
        float z = transform.position.z + ((forward+right).normalized).z*Velocity;
        x = Mathf.Min(Mathf.Max(x, MinPosition.x), MaxPosition.x);
        z = Mathf.Min(Mathf.Max(z, MinPosition.y), MaxPosition.y);
        transform.position = new Vector3(x, transform.position.y, z);
	}
}
