using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Creep : MonoBehaviour {
	private int player;
	public int Supply;
    public float MineAtt;
	public float Attack;
	public float AttDelay;
	public float MineDelay;
	public int Threat;

	private float dist;
	private Bezier bezier;
    private GameObject mine;
	private GameObject baseEnemy;
	private float timerMine;
	private float timerAtt;
    private float _TimerSlow;
    private float _SlowEffect;
	private Connection_GUI connection;
	private bool start = false;
	public float life = 1;
	public float velocity = 1;

	public void init(GameObject mine, int player, int type){
		dist = 0;
		this.player = player;
        this.mine = mine;
		baseEnemy = GameObject.FindGameObjectWithTag("Base"+(1-player));
		GameObject b = GameObject.FindGameObjectWithTag("Bezier"+(1-player));
		bezier = (Bezier)b.GetComponent("Bezier");
		start = true;
		GameObject con = GameObject.FindGameObjectWithTag("Connection_GUI");
		connection = (Connection_GUI)con.GetComponent("Connection_GUI");
		life = connection.CreepLife[type];
		velocity = connection.CreepVelocity[type];
	}

    void Slow(){
        _TimerSlow -= Time.deltaTime;

        if (_TimerSlow < 0){
            _SlowEffect = 0;
            _TimerSlow = 0;
        } 
    }
	
	// Update is called once per frame
	void Update () {
		if (!start || !Network.isServer) return;
		timerMine += Time.deltaTime;
		timerAtt += Time.deltaTime;
        Slow();

		if(mine == null || (mine.transform.position - transform.position).magnitude > 5){
            dist += (velocity-_SlowEffect) * Time.deltaTime;
			bool ret = bezier.go(gameObject, dist);
			connection.networkView.RPC("walkCreep", RPCMode.Others, networkView.viewID, transform.position, transform.rotation);
			
			if((!ret) && (baseEnemy != null && timerAtt >= AttDelay)){
				Base b = (Base) baseEnemy.GetComponent("Base");
				b.dano(Attack);
				connection.networkView.RPC("danoBase", RPCMode.Others, baseEnemy.networkView.viewID, Attack);
				timerAtt = 0;
            }
        }
        else if(timerMine >= MineDelay){
            Mine m = (Mine) mine.GetComponent("Mine");
			float res = m.dano(MineAtt);
			connection.networkView.RPC("danoMine", RPCMode.Others, m.networkView.viewID, res, player);
			if (m.Gold <= 0) Destroy(mine);
			timerMine = 0;
        }
	}

	public bool dano(float damage){
		life -= damage;
		if (life <= 0){
			Destroy(gameObject);
			return true;
		}
		return false;
	}

    public void slow(float slow, float duration){
        _TimerSlow = duration;
		_SlowEffect = (slow > velocity) ? velocity : slow;
    }
}
