using UnityEngine;
using System.Collections;
using System;
using System.Collections.Generic;

public class Game_GUI : MonoBehaviour {

    public const int DEFAULT = 0;
	public const int TOWER = 1;
	public const int TECH = 2;
	public const int CREEP = 3;
	public const int TARGET = 4;

	public List<float> upLife;
	public List<int> costLife;
	public List<float> upVelocity;
	public List<int> costVelocity;
	private int cont_upLife;
	private int cont_upVelocity;
	private int cont_tank;
	private int cont_soldier;
	private Connection_GUI connection;

	void Start(){
		cont_upLife = 0;
		cont_upVelocity = 0;
		cont_tank = 0;
		cont_soldier = 0;
		GameObject con = GameObject.FindGameObjectWithTag("Connection_GUI");
		connection = (Connection_GUI)con.GetComponent("Connection_GUI");
	}

    void OnGUI(){
		int id = (Network.isServer) ? 0 : 1;
		GameObject go = GameObject.FindGameObjectWithTag("Player"+id);
        Player player = (Player)go.GetComponent("Player");

		GUI.Box(new Rect(Screen.width - 200, 0, 200, 20), String.Format("Gold: {0,-5} Supply: {0,-5}", (int)connection.Gold[id], (int)player.Supply));
        if(player.getState() == DEFAULT){
            if (GUI.Button (new Rect (0,Screen.height - 80,100,80), "Tower")) {
                player.setState(TOWER);
	        }
            else if (GUI.Button (new Rect (100,Screen.height - 80,100,80), "Tech")) {
                player.setState(TECH);
	        }
            else if (GUI.Button (new Rect (200,Screen.height - 80,100,80), "Creep")) {
                player.setState(CREEP);
            }
			else if (GUI.Button(new Rect(300, Screen.height - 80, 100, 80), "Target")){
				player.setState(TARGET);
			}
        }
        else if(player.getState() == TOWER){
			if (GUI.Button(new Rect(0, Screen.height - 80, 100, 80), "Crippling Tower")){
                player.setCurrentTower(0);
	        }
			else if (GUI.Button(new Rect(100, Screen.height - 80, 100, 80), "Machine Gun")){
                player.setCurrentTower(1);
	        }
			else if (GUI.Button(new Rect(200, Screen.height - 80, 100, 80), "Back")){
				player.setState(DEFAULT);
			}
        }
		else if (player.getState() == TECH){
			if (cont_upVelocity < upVelocity.Count && GUI.Button(new Rect(0, Screen.height - 80, 100, 80), "Light Weight(" + (cont_upVelocity + 1) + ")")){
				connection.CreepVelocity[0] += upVelocity[cont_upVelocity];
				connection.CreepVelocity[1] += upVelocity[cont_upVelocity];
				cont_upVelocity++;
			}
			else if (cont_upLife < upLife.Count && GUI.Button(new Rect(100, Screen.height - 80, 100, 80), "Improve Armor(" + (cont_upLife + 1) + ")")){
				connection.CreepLife[0] += upLife[cont_upLife];
				connection.CreepLife[1] += upLife[cont_upLife];
				cont_upLife++;
			}
			else if (GUI.Button(new Rect(200, Screen.height - 80, 100, 80), "Back")){
				player.setState(DEFAULT);
			}
		}
		else if (player.getState() == CREEP){
			if (cont_upVelocity < upVelocity.Count && GUI.Button(new Rect(0, Screen.height - 80, 100, 80), "Tank(" + cont_tank + ")")){
				if(player.addCreep(0)) cont_tank++;
			}
			else if (cont_upLife < upLife.Count && GUI.Button(new Rect(100, Screen.height - 80, 100, 80), "Soldier(" +cont_soldier + ")")){
				if (player.addCreep(1)) cont_soldier++;
			}
			else if (GUI.Button(new Rect(200, Screen.height - 80, 100, 80), "Clear")){
				cont_tank = 0;
				cont_soldier = 0;
				player.wave.Clear();
			}
			else if (GUI.Button(new Rect(300, Screen.height - 80, 100, 80), "Back")){
				player.setState(DEFAULT);
			}
		}
		else if (player.getState() == TARGET){
			GameObject[] mines = (GameObject[])GameObject.FindGameObjectsWithTag("Mine"+(1-id));
			List<Mine> ms = new List<Mine>();
			List<int> ls = new List<int>();
			ms.Add(null); ls.Add(3);
			ms.Add(null); ls.Add(3);
			ms.Add(null); ls.Add(3);
			
			foreach (GameObject g in mines){
				Mine m = (Mine)g.GetComponent("Mine");
				ms[m.pos] = m;
			}
			for (int i = 0, j = 0; i < 3; i++){
				if (ms[i] == null){
					ls[i] = 3;
				}
				else{
					ls[i] = j;
					j++;
				}
			}


			if (ms[0] != null && GUI.Button(new Rect(0, Screen.height - 80, 100, 80), "Mine 1")){
				player.setCurrentMine(ls[0]);
			}
			else if (ms[1] != null && cont_upLife < upLife.Count && GUI.Button(new Rect(100, Screen.height - 80, 100, 80), "Mine 2")){
				player.setCurrentMine(ls[1]);
			}
			else if (ms[2] != null && GUI.Button(new Rect(200, Screen.height - 80, 100, 80), "Mine 3")){
				player.setCurrentMine(ls[2]);
			}
			else if (GUI.Button(new Rect(300, Screen.height - 80, 100, 80), "Base")){
				player.setCurrentMine(3);
			}
			else if (GUI.Button(new Rect(400, Screen.height - 80, 100, 80), "Back")){
				player.setState(DEFAULT);
			}
		}
    }


}
