using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;

public class Player : MonoBehaviour {
    public float Supply;
    public List<GameObject> CreepsType;
    public List<GameObject> TowersType;

	public List<int> wave;
    private int currentMine;
    private int currentTower;
    private int currentCreep;
    private float timer;
    private List<bool> enabledTowers;
    private List<bool> enabledCreeps;
    private List<bool> enabledWays;
    private int state;
	private Connection_GUI connection;
	private int player;

    public void setCurrentMine(int val){
        this.currentMine = val;
    }

    public int getCurrentMine(){
        return currentMine;
    }

    public void setCurrentTower(int val){
        this.currentTower = val;
    }

    public int getCurrentCreep(){
        return currentCreep;
    }

    public void setCurrentCreep(int val){
        this.currentCreep = val;
    }
    public void setState(int state){
        this.state = state;
    }
    public int getState(){
        return state;
    }

    public void Start(){
		int qtdWays = 3;
		state = 0;
        currentMine = 0;
        timer = 0;
        //currentWaypoint = 0;
        currentTower = -1;
        currentCreep = 0;
        enabledCreeps = new List<bool>();
        enabledCreeps.Add(true);
        for (int i = 1; i < CreepsType.Count; i++){
            enabledCreeps.Add(false);
        }
        enabledTowers = new List<bool>();
        enabledTowers.Add(true);
        for (int i = 1; i < TowersType.Count; i++)
        {
            enabledTowers.Add(false);
        }
        wave = new List<int>();
        enabledWays = new List<bool>();
        for (int i = 0; i < qtdWays; i++){
            enabledWays.Add(true);
        }
		GameObject go = GameObject.FindGameObjectWithTag("Connection_GUI");
		connection = (Connection_GUI)go.GetComponent("Connection_GUI");
		player = (Network.isServer) ? (0) : (1);
    }

    public void addGold(float value){
		connection.Gold[player] += value;
    }
    
    private Vector3 getPoint(){
        Ray raio = gameObject.camera.ScreenPointToRay(Input.mousePosition);
        Vector3 dir = raio.direction;
        Vector3 camera = gameObject.camera.transform.position;
        float t = (-camera.y) / (dir.y);
        return new Vector3((dir.x * t) + camera.x, 0f, (dir.z * t) + camera.z);
    }

    public void buildTower(){
        //if (!enabledTowers[towerInd]) return;
		Tower type = (Tower)TowersType[currentTower].GetComponent("Tower");
		if (connection.Gold[player] >= type.Cost){
            Vector3 pos = getPoint();

			int id = (Network.isServer) ? 0 : 1;
			GameObject[] squares = GameObject.FindGameObjectsWithTag("Square" + id);

            foreach (GameObject square in squares){
                if ((square.transform.position - pos).magnitude < 7){
					Network.Instantiate(TowersType[currentTower], square.transform.position, square.transform.rotation, 0);
					Network.Destroy(square);
					connection.Gold[player] -= type.Cost;
					currentTower = -1;
                    break;
                }
            }
        }
    }

    public void changeWaypoints(int value){
        //if(enabledWays[value]) currentWaypoint = value;
    }

    private int countSupply(){
        int result = 0;
        foreach(int i in wave){
            Creep creep = (Creep) CreepsType[i].GetComponent("Creep");
            result += creep.Supply;
        }
        return result;
    }

    public bool addCreep(int creepInd){
        Creep creep = (Creep) CreepsType[creepInd].GetComponent("Creep");
        if(Supply - countSupply() >= creep.Supply){
            wave.Add(creepInd);
			return true;
        }
		return false;
    }
    
    public void clearCreep(){
        wave.Clear();
    }

    private void setGold(){
		GameObject[] mines = (GameObject[])GameObject.FindGameObjectsWithTag("Mine"+player);
		float total = 30;
		foreach (GameObject m in mines){
			Mine m0 = (Mine)m.GetComponent("Mine");
			if (m0.pos == 0) total += 0.1f * m0.Gold;
			if (m0.pos == 1) total += 0.2f * m0.Gold;
			if (m0.pos == 2) total += 0.3f * m0.Gold;
		}
		connection.Gold[player] += (total * Time.deltaTime);
	}
	
    public void throwsCreeps(){
		int id = (Network.isServer) ? 0 : 1;
		GameObject[] minesEnemy = GameObject.FindGameObjectsWithTag("Mine"+(1-id));
		GameObject go = GameObject.FindGameObjectWithTag("Bezier"+(1-id));
		Bezier wayEnemy = (Bezier)go.GetComponent("Bezier");

		if (currentMine < minesEnemy.Length){
			foreach (int i in wave){
				GameObject c = (GameObject)Network.Instantiate(CreepsType[i], wayEnemy.points[0], Quaternion.LookRotation(wayEnemy.points[1] - wayEnemy.points[0]), 0);
				GameObject[] creeps = GameObject.FindGameObjectsWithTag("Creep" + id);
				Creep creep = (Creep)(creeps[creeps.Length - 1].GetComponent("Creep"));
				creep.init(minesEnemy[currentMine], id, i);
				connection.networkView.RPC("initCreep", RPCMode.Others, currentMine, id, c.networkView.viewID, i);
			}
		}
		else{
			foreach (int i in wave){
				GameObject c = (GameObject)Network.Instantiate(CreepsType[i], wayEnemy.points[0], Quaternion.LookRotation(wayEnemy.points[1] - wayEnemy.points[0]), 0);
				GameObject[] creeps = GameObject.FindGameObjectsWithTag("Creep" + id);
				Creep creep = (Creep)(creeps[creeps.Length - 1].GetComponent("Creep"));
				creep.init(null, id, i);
				connection.networkView.RPC("initCreep", RPCMode.Others, currentMine, id, c.networkView.viewID, i);
			}
		}
    }

	void Update () {
        timer += Time.deltaTime;
		setGold();
 		if (timer > 5)
		{
			Supply += 5;
			throwsCreeps();
            timer = 0;
		}

		if (currentTower != -1 && Input.GetMouseButtonUp(0)){
			buildTower();
		}
	}
}
