using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public abstract class Tower : MonoBehaviour {

    public float AttackSpeed;
    public float Range;
	public GameObject Bullet;
    public int Cost;

	protected Connection_GUI connection;
    protected float tempo;
	private int player;
	
	// Use this for initialization
	protected void Start () {
        tempo = AttackSpeed;
		player = (Network.isServer) ? (0) : (1);
		GameObject con = GameObject.FindGameObjectWithTag("Connection_GUI");
		connection = (Connection_GUI)con.GetComponent("Connection_GUI");
	}

	// Update is called once per frame
    protected void Update(){
		if (!networkView.isMine) return;

        tempo = Mathf.Min(Time.deltaTime + tempo, AttackSpeed);
        if (tempo >= AttackSpeed){
			GameObject creep = chooseCreep();
			if (creep == null) return;
            GameObject b = (GameObject) Network.Instantiate(Bullet, transform.position, Quaternion.identity, 0);
			GameObject[] bullets = GameObject.FindGameObjectsWithTag("Bullet" + player);
			Bullet bullet = (Bullet)(bullets[bullets.Length - 1].GetComponent("Bullet"));
			bullet.init(creep, gameObject);
			connection.networkView.RPC("initBullet", RPCMode.Others, b.networkView.viewID, creep.networkView.viewID, networkView.viewID);
            tempo = 0;
        }
    }

	private GameObject chooseCreep(){
		GameObject[] creeps = (GameObject[])GameObject.FindGameObjectsWithTag("Creep"+(1-player));
		GameObject target = null;
		int mai = -1;
		foreach (GameObject creep in creeps){
            Vector3 desl = (creep.transform.position - transform.position);
			Creep c = (Creep)creep.GetComponent("Creep");
			if (c.Threat > mai && desl.magnitude < Range){
				target = creep;
				mai = c.Threat;
			}
		}
		return target;
	}

    public abstract void Attack_Creep(GameObject creep);
}
